/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 neuron <neuron@hollowtube.mine.nu>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/* Minimum time between /proc/stat reads */
#define MIN_PROCTIME 500000

#ifndef IOWAIT_HEADER
#define IOWAIT_HEADER 1
#include <sys/time.h>
int proc_stat_fd;
unsigned long long old_cpuuser, old_cpunice, old_cpusystem, old_cpuidle,
    old_cpuiowait, old_cpuxxx, old_cpuyyy;
unsigned long long current_cpuuser, current_cpunice, current_cpusystem,
    current_cpuidle, current_cpuiowait, current_cpuxxx, current_cpuyyy;

struct timeval current_time;
struct timeval old_time;
struct timezone null_timezone;
#endif

#define TOTAL (current_cpuuser + current_cpunice + current_cpusystem)
#define TICKS (TOTAL + current_cpuidle)
#define CLEARNUMBERS current_cpuuser = current_cpunice = current_cpusystem = current_cpuidle = current_cpuiowait = current_cpuxxx = current_cpuyyy = 99;

#define getcurrent(value) value = (value > 0) ? ((value*HZ)/TICKS) : 0

#define PROC_STAT "/proc/stat"
#define set_procstat_value(value,old) x = value; value = value - old; old = x;

void iowait_init(void);
int do_recheck(void);
void collectstat(void);
